diff --git a/corefreq-cli.c b/corefreq-cli.c
index 09d40f8..2eb5f8a 100644
--- a/corefreq-cli.c
+++ b/corefreq-cli.c
@@ -2209,23 +2209,29 @@ void MemoryController(Window *win, CELL_FUNC OutFunc)
 	PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
 	PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
 
-      for (slot = 0; slot < Shm->Uncore.MC[mc].SlotCount; slot++) {
+      for (slot = 0; slot < Shm->Uncore.MC[mc].SlotCount; slot++)
+      {
 	PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
 	PRT(IMC, attrib[1], "\x20\x20#%-2u", slot);
-	PRT(IMC, attrib[1],
+	    if (Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size > 0) {
+		PRT(IMC, attrib[1],
 		"%5u",Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks);
-	PRT(IMC, attrib[1],
+		PRT(IMC, attrib[1],
 		"%5u",Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Ranks);
-	iSplit(Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows, hInt);
-	PRT(IMC, attrib[1], "%5s", &hInt[0]);
-	PRT(IMC, attrib[1], "%5s", &hInt[8]);
-	iSplit(Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols, hInt);
-	PRT(IMC, attrib[1], "%5s", &hInt[0]);
-	PRT(IMC, attrib[1], "%5s", &hInt[8]);
-	PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
-	iSplit(Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size, hInt);
-	PRT(IMC, attrib[1], "%5s", &hInt[0]);
-	PRT(IMC, attrib[1], "%5s", &hInt[8]);
+		iSplit(Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows, hInt);
+		PRT(IMC, attrib[1], "%5s", &hInt[0]);
+		PRT(IMC, attrib[1], "%5s", &hInt[8]);
+		iSplit(Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols, hInt);
+		PRT(IMC, attrib[1], "%5s", &hInt[0]);
+		PRT(IMC, attrib[1], "%5s", &hInt[8]);
+		PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
+		iSplit(Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size, hInt);
+		PRT(IMC, attrib[1], "%5s", &hInt[0]);
+		PRT(IMC, attrib[1], "%5s", &hInt[8]);
+	    }
+	    else for (nc = 0; nc < 9; nc++) {
+		PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
+	    }
 	PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
 	PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
 	PRT(IMC, attrib[0], RSC(MEM_CTRL_BLANK).CODE());
diff --git a/corefreqd.c b/corefreqd.c
index ae546c2..c0b3c66 100644
--- a/corefreqd.c
+++ b/corefreqd.c
@@ -2027,22 +2027,24 @@ void HSW_IMC(SHM_STRUCT *Shm, PROC *Proc)
 
 unsigned int SKL_DimmWidthToRows(unsigned int width)
 {
+	unsigned int rows = 0;
 	switch (width) {
 	case 0b00:
-		return(1 << 14);
+		rows = 8;
+		break;
 	case 0b01:
-		return(1 << 15);
+		rows = 16;
+		break;
 	case 0b10:
-		return(1 << 16);
-	case 0b11:
-		return(1 << 0);
+		rows = 32;
+		break;
 	}
-	return(1 << 0);
+	return(8 * 1024 * rows);
 }
 
 void SKL_IMC(SHM_STRUCT *Shm, PROC *Proc)
 {
-    unsigned short mc, cha, slot;
+    unsigned short mc, cha;
 
     Shm->Uncore.CtrlCount = Proc->Uncore.CtrlCount;
     for (mc = 0; mc < Shm->Uncore.CtrlCount; mc++)
@@ -2098,15 +2100,16 @@ void SKL_IMC(SHM_STRUCT *Shm, PROC *Proc)
 		break;
 	}
 
-      for (slot = 0; slot < Shm->Uncore.MC[mc].SlotCount; slot++)
-      {
-	Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks = 8;
+	Shm->Uncore.MC[mc].Channel[cha].DIMM[0].Banks =			\
+	Shm->Uncore.MC[mc].Channel[cha].DIMM[1].Banks =			\
+	Proc->Uncore.MC[mc].Channel[cha].SKL.Sched.DRAM_Tech == 0b00 ? 16 : 8;
 
-	Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols =
-			Proc->Uncore.MC[mc].Channel[cha].SKL.Sched.Dimm_x8 ?
-				  (1 << 13)
-				: (1 << 10);
-      }
+	Shm->Uncore.MC[mc].Channel[cha].DIMM[0].Cols =			\
+		Proc->Uncore.MC[mc].Channel[cha].SKL.Sched.x8_device_Dimm0 ?
+			1024 : 0;
+	Shm->Uncore.MC[mc].Channel[cha].DIMM[1].Cols =			\
+		Proc->Uncore.MC[mc].Channel[cha].SKL.Sched.x8_device_Dimm1 ?
+			1024 : 0;
      }
 	Shm->Uncore.MC[mc].Channel[0].Timing.ECC =
 				Proc->Uncore.MC[mc].SKL.MADC0.ECC;
diff --git a/corefreqk.c b/corefreqk.c
index da5ee0a..6c446ed 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -3762,16 +3762,11 @@ void ThermalMonitor_Set(CORE *Core)
 void PowerThermal(CORE *Core)
 {
   CLOCK_MODULATION ClockModulation = {.value = 0};
-  /* blackList :			ODCM
-	_Atom_Airmont,			06_4C
-	_IvyBridge			06_3A
-	_Kabylake,			06_9E
-  */
   struct {
 	struct SIGNATURE Arch;
-	unsigned int	grantPWR_MGMT	:  1-0,
+	unsigned short	grantPWR_MGMT	:  1-0,
 			grantODCM	:  2-1,
-			freeToUse	: 32-2;
+			freeToUse	: 16-2;
   } whiteList[] = {
 	{_Core_Yonah,		0, 1},
 	{_Core_Conroe,		0, 1},
@@ -3779,40 +3774,56 @@ void PowerThermal(CORE *Core)
 	{_Core_Conroe_616,	0, 1},
 	{_Core_Penryn,		0, 1},
 	{_Core_Dunnington,	0, 1},
+
 	{_Atom_Bonnell ,	0, 1},	/* 06_1C */
 	{_Atom_Silvermont,	0, 1},	/* 06_26 */
 	{_Atom_Lincroft,	0, 1},	/* 06_27 */
 	{_Atom_Clovertrail,	0, 1},	/* 06_35 */
 	{_Atom_Saltwell,	0, 1},	/* 06_36 */
+
 	{_Silvermont_637,	0, 1},	/* 06_37 */
-	{_Atom_Merrifield,	0, 1},	/* 06_4A */
+
 	{_Atom_Avoton,		0, 1},	/* 06_4D */
-	{_Atom_Moorefield,	0, 1},	/* 06_5A */
+	{_Atom_Airmont ,	0, 0},	/* 06_4C */
 	{_Atom_Goldmont,	1, 0},	/* 06_5C */
 	{_Atom_Sofia,		0, 1},	/* 06_5D */
+	{_Atom_Merrifield,	0, 1},	/* 06_4A */
+	{_Atom_Moorefield,	0, 1},	/* 06_5A */
+
 	{_Nehalem_Bloomfield,	1, 1},	/* 06_1A */
 	{_Nehalem_Lynnfield,	1, 1},	/* 06_1E */
 	{_Nehalem_MB,		1, 1},	/* 06_1F */
 	{_Nehalem_EX,		1, 1},	/* 06_2E */
+
 	{_Westmere,		1, 1},	/* 06_25 */
 	{_Westmere_EP,		1, 1},	/* 06_2C */
 	{_Westmere_EX,		1, 1},	/* 06_2F */
+
 	{_SandyBridge,		1, 1},	/* 06_2A */
 	{_SandyBridge_EP,	1, 1},	/* 06_2D */
+
+	{_IvyBridge,		1, 0},	/* 06_3A */
 	{_IvyBridge_EP ,	1, 1},	/* 06_3E */
+
 	{_Haswell_DT,		1, 1},	/* 06_3C */
 	{_Haswell_EP,		1, 1},	/* 06_3F */
 	{_Haswell_ULT,		1, 1},	/* 06_45 */
 	{_Haswell_ULX,		1, 1},	/* 06_46 */
+
 	{_Broadwell,		1, 1},	/* 06_3D */
 	{_Broadwell_D,		1, 1},	/* 06_56 */
 	{_Broadwell_H,		1, 1},	/* 06_47 */
 	{_Broadwell_EP ,	1, 1},	/* 06_4F */
+
 	{_Skylake_UY,		1, 1},	/* 06_4E */
-	{_Skylake_S,		1, 1},	/* 06_5E */
+	{_Skylake_S,		1, 0},	/* 06_5E */
 	{_Skylake_X,		1, 1},	/* 06_55 */
+
 	{_Xeon_Phi,		0, 1},	/* 06_57 */
+
+	{_Kabylake,		1, 0},	/* 06_9E */
 	{_Kabylake_UY,		1, 1},	/* 06_8E */
+
 	{_Cannonlake,		1, 1},	/* 06_66 */
 	{_Geminilake,		1, 0},	/* 06_7A */
 	{_Icelake_UY,		1, 1},	/* 06_7E */
@@ -3826,7 +3837,8 @@ void PowerThermal(CORE *Core)
 		break;
 	}
   }
-  if (Proc->Features.Info.LargestStdFunc >= 0x6) {
+  if (Proc->Features.Info.LargestStdFunc >= 0x6)
+  {
     struct THERMAL_POWER_LEAF Power = {{0}};
 
     __asm__ volatile
@@ -3848,7 +3860,8 @@ void PowerThermal(CORE *Core)
 	: "%rax", "%rbx", "%rcx", "%rdx"
     );
     if (Power.ECX.SETBH == 1) {
-      if ((id < ids) && (whiteList[id].grantPWR_MGMT == 1)){
+      if ((id < ids) && (whiteList[id].grantPWR_MGMT == 1))
+      {
 	RDMSR(Core->PowerThermal.PerfEnergyBias, MSR_IA32_ENERGY_PERF_BIAS);
 	RDMSR(Core->PowerThermal.PwrManagement, MSR_MISC_PWR_MGMT);
 
@@ -3879,7 +3892,9 @@ void PowerThermal(CORE *Core)
     else
 	BITCLR(LOCKLESS, Proc->PowerMgmt, Core->Bind);
 
-    if (Proc->Features.Std.EDX.ACPI == 1) {
+    if ((Proc->Features.Std.EDX.ACPI == 1)
+     && (id < ids) && (whiteList[id].grantODCM == 1))
+    {
 	int ToggleFeature = 0;
 
 	RDMSR(ClockModulation, MSR_IA32_THERM_CONTROL);
@@ -3898,7 +3913,7 @@ void PowerThermal(CORE *Core)
 	    ClockModulation.DutyCycle = ODCM_DutyCycle << !ClockModulation.ECMD;
 	    ToggleFeature = 1;
 	}
-	if((ToggleFeature == 1) && (id < ids) && (whiteList[id].grantODCM == 1))
+	if (ToggleFeature == 1)
 	{
 	    WRMSR(ClockModulation, MSR_IA32_THERM_CONTROL);
 	    RDMSR(ClockModulation, MSR_IA32_THERM_CONTROL);
@@ -3910,8 +3925,9 @@ void PowerThermal(CORE *Core)
 	else
 		BITCLR(LOCKLESS, Proc->ODCM, Core->Bind);
     }
-    else
+    else {
 	BITCLR(LOCKLESS, Proc->ODCM, Core->Bind);
+    }
   }
   else {
 	BITCLR(LOCKLESS, Proc->PowerMgmt, Core->Bind);
diff --git a/coretypes.h b/coretypes.h
index ae39046..20b5a28 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.42.0"
+#define COREFREQ_VERSION	"1.42.1"
 
 enum {	GenuineIntel,
 	Core_Yonah,
diff --git a/intelmsr.h b/intelmsr.h
index fe89bb7..cab6490 100644
--- a/intelmsr.h
+++ b/intelmsr.h
@@ -1790,7 +1790,7 @@ typedef union
 	unsigned int		value;
 	struct {
 		unsigned int
-		tRP		:  6-0, /* Holds parameter tRP (and tRCD) ! */
+		tRP		:  6-0,  /* Holds parameter tRP (and tRCD) ! */
 		tRPab_ext	:  8-6,
 		tRAS		: 15-8,
 		ReservedBits1	: 16-15,
@@ -1807,11 +1807,12 @@ typedef union
 	struct {
 		unsigned int
 		DRAM_Tech	:  2-0,/* 00:DDR4 01:DDR3 10:LPDDR3 11:Illegal*/
-		CMD_Stretch	:  4-2, /* 00:1N , 01:2N , 10:3N , 11:1N */
+		CMD_Stretch	:  4-2,  /* 00:1N , 01:2N , 10:3N , 11:1N */
 		N_to_1_ratio	:  7-4,
 		ReservedBits	:  8-7,
 		Addr_Mirroring	: 10-8,
-		Dimm_x8		: 12-11,
+		x8_device_Dimm0	: 11-10, /* LSB is for DIMM 0		*/
+		x8_device_Dimm1	: 12-11, /* MSB is for DIMM 1		*/
 		tCPDED		: 15-12,
 		LPDDR_2N_CS	: 16-15,
 		Reset_OnCmd	: 20-16,
